PSvars_ClassBGColors = nil;
PSvars_ClassTextColors = nil;
PSvars_MaxTargets = nil;
if (GetLocale() == "enUS") then
  PopupModeList =
  {
  "UPWARD",
  "DOWNWARD",
  "RESET",
  n = 3;
  };

  IconList =
  {
  "OFF",
  "FREE MOVING",
  "ON MINIMAP",
  n = 3;
  };

  StorageMode =
  {
  "ALL",
  "ALL PLAYERS",
  "NPCS",
  "NONE",
  n = 4;
  };

  AnnounceMode =
  {
  "AUTO",
  "SELF",
  "SAY",
  "PARTY",
  "RAID",
  "YELL",
  "LOCAL DEFENSE",
  "OFF",
  n = 8;
  };

  PingModeList =
  {
  "ALWAYS",
  "INSIDE BG",
  "OUTSIDE BG",
  "WHEN ANNOUNCING",
  "OFF",
  n = 5;
  };

  TooltipModeList =
  {
  "NORMAL",
  "CLASS",
  "CLASS LEVEL",
  n = 3;
  };

  TimeMode =
  {
  "15 SECONDS",
  "30 SECONDS",
  "1 MINUTE",
  "3 MINUTES",
  "5 MINUTES",
  "10 MINUTES",
  "OFF",
  n = 7;
  };

  HealMode =
  {
  "20 SECONDS",
  "40 SECONDS",
  "1 MINUTE",
  "2 MINUTES",
  "3 MINUTES",
  "OFF",
  n = 6;
  };

  ScaleMode =
  {
  "LARGE",
  "MEDIUM",
  "SMALL",
  "SMALLEST",
  n = 4;
  };

  MOMode =
  {
  "ALL",
  "ALL PLAYERS",
  "ENEMIES",
  "ENEMY PLAYERS",
  "FLAGGED AND ELITE ENEMIES",
  n = 5;
  };

  TrackMode =
  {
  "ALL",
  "ALL PLAYERS",
  "ENEMIES",
  "ENEMY PLAYERS",
  "FLAGGED AND ELITE ENEMIES",
  n = 5;
  };

  AddonMode =
  {
  "ENABLED",
  "BG/ARENAS ONLY",
  "ONLY OUTSIDE BG/ARENAS",
  "DISABLED",
  n = 4;
  };

  AutoList =
  {
  "ENABLED",
  "DISABLED",
  "ONLY IF THEY DAMAGE ME",
  n = 3;
  };

  KeepList =
  {
  "ENABLED",
  "DISABLED",
  n = 2;
  };

elseif (GetLocale() == "frFR") then
  PopupModeList =
  {
  "EN HAUT",
  "EN BAS",
  "RÉINITIALISE",
  n = 3;
  };

  IconList =
  {
  "OFF",
  "MOUVEMENT LIBRE",
  "SUR LA MINICARTE",
  n = 3;
  };

  StorageMode =
  {
  "TOUS",
  "TOUS JOUEURS",
  "NPCS",
  "PERSONNE",
  n = 4;
  };

  AnnounceMode =
  {
  "AUTO",
  "PERSONNEL",
  "DIRE",
  "PARTIE",
  "RAID",
  "CRI",
  "DÉFENSE LOCALE",
  "OFF",
  n = 8;
  };

  PingModeList =
  {
  "TOUJOURS",
  "À L'INTÉRIEUR BG/ARÈNE",
  "À L'EXTÉRIEUR BG/ARÈNE",
  "En ANNONÇANT",
  "OFF",
  n = 5;
  };

  TooltipModeList =
  {
  "NORMAL",
  "CLASSE",
  "CLASSE NIVEAU",
  n = 3;
  };

  TimeMode =
  {
  "15 SECONDES",
  "30 SECONDES",
  "1 MINUTE",
  "3 MINUTES",
  "5 MINUTES",
  "10 MINUTES",
  "OFF",
  n = 7;
  };

  HealMode =
  {
  "20 SECONDES",
  "40 SECONDES",
  "1 MINUTE",
  "2 MINUTES",
  "3 MINUTES",
  "OFF",
  n = 6;
  };

  ScaleMode =
  {
  "GRAND",
  "MOYEN",
  "PETIT",
  "PLUS PETIT",
  n = 4;
  };

  MOMode =
  {
  "TOUS",
  "TOUS JOUEURS",
  "ENNEMIS",
  "JOUEURS ENNEMIS",
  "FLAGGED ET-OU ENNEMIS ÉLITAIRES",
  n = 5;
  };

  TrackMode =
  {
  "TOUS",
  "TOUS JOUEURS",
  "ENNEMIS",
  "JOUEURS ENNEMIS",
  "FLAGGED ET-OU ENNEMIS ÉLITAIRES",
  n = 5;
  };

  AddonMode =
  {
  "ACTIVÉ",
  "BG/ARÈNE SEULEMENT",
  "SEULEMENT À L'EXTÉRIEUR BG/ARÈNE",
  "DÉSACTIVÉ",
  n = 4;
  };

  AutoList =
  {
  "ACTIVÉ",
  "DÉSACTIVÉ",
  "SEULEMENT S'ILS M'DOMMAGE",
  n = 3;
  };

  KeepList =
  {
  "ACTIVÉ",
  "DÉSACTIVÉ",
  n = 2;
  };
elseif (GetLocale() == "deDE") then
  PopupModeList =
  {
  "NACH OBEN",
  "NACH UNTEN",
  "ZUR\195\188CKSETZEN",
  n = 3;
  };

  IconList =
  {
  "AUS",
  "FREIES BEWEGEN",
  "AN DER MINIMAP",
  n = 3;
  };

  StorageMode =
  {
  "ALLE",
  "ALLE SPIELER",
  "NPCS",
  "NIEMAND",
  n = 4;
  };

  AnnounceMode =
  {
  "AUTOMATISCH",
  "SELBST",
  "SAGEN",
  "GRUPPE",
  "SCHLACHTZUG",
  "SCHREIEN",
  "LOKALE VERTEIDIGUNG",
  "AUS",
  n = 8;
  };

  PingModeList =
  {
  "IMMER",
  "INNERHALB VON BG/ARENA",
  "AU\195\159ERHALB VON BG/ARENA",
  "BEI BEKANNTGABE",
  "AUS",
  n = 5;
  };

  TooltipModeList =
  {
  "NORMAL",
  "KLASSE",
  "KLASSE/STUFE",
  n = 3;
  };

  TimeMode =
  {
  "15 SEKUNDEN",
  "30 SEKUNDEN",
  "1 MINUTE",
  "3 MINUTEN",
  "5 MINUTEN",
  "10 MINUTEN",
  "AUS",
  n = 7;
  };

  HealMode =
  {
  "20 SEKUNDEN",
  "40 SEKUNDEN",
  "1 MINUTE",
  "2 MINUTEN",
  "3 MINUTEN",
  "AUS",
  n = 6;
  };

  ScaleMode =
  {
  "GRO\195\159",
  "MITTEL",
  "KLEIN",
  "SEHR KLEIN",
  n = 4;
  };

  MOMode =
  {
  "ALLE",
  "ALLE SPIELER",
  "FEINDE",
  "FEINDL. SPIELER",
  "PVP- UND ELITE-GEGNER",
  n = 5;
  };

  TrackMode =
  {
  "ALLE",
  "ALLE SPIELER",
  "FEINDE",
  "FEINDL. SPIELER",
  "PVP- UND ELITE-GEGNER",
  n = 5;
  };

  AddonMode =
  {
  "AKTIVIERT",
  "NUR INNERHALB VON BG/ARENA",
  "NUR AU\195\159ERHALB VON BG/ARENA",
  "DEAKTIVIERT",
  n = 4;
  };

  AutoList =
  {
  "AKTIVIERT",
  "DEAKTIVIERT",
  "BEI FEINDL. ANGRIFF",
  n = 3;
  };

  KeepList =
  {
  "AKTIVIERT",
  "DEAKTIVIERT",
  n = 2;
  };
end

local oldMO = "";
local oldTrack = "";
local MaxBackup = "";
local PS_Neutral = "";
local PS_BG = "";
local PS_Announce = "";
local PS_AutoNotify = "";
local PS_Storage = "";
local PS_IconMode = "";
local PS_BGMode = "";
local PS_PopupMode = "";
local PS_Scalebackup = "";
local PS_PMbackup = "";
local PS_PingMode = "";
local PS_Sentry = "";
local PS_Time = "";
local PS_Addon = "";
local PS_Sound = "";
local PS_scale = "";
local PS_MO = "";
local PS_track = "";
local PS_Death = "";
local PS_Pet = "";
local PS_Damage = "";
local PS_Healer = "";
local PS_Heal = "";
local PS_SplitMode = "";
local KeepMode = "";
local GrabSpell = "";
local Show = "";

function PS_OptionsForm_LoadCombos()

  id = getglobal( "PS_OptionsFormSentryType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeSentryButtons);
  id = getglobal( "PS_OptionsFormSentryNeut" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeNeutralButtons);
  id = getglobal( "PS_OptionsFormSoundType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeSoundButtons);
  id = getglobal( "PS_OptionsFormStorageMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeStorageButtons);
  id = getglobal( "PS_OptionsFormAnnounceMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeAnnounceButtons);
  id = getglobal( "PS_OptionsFormAutoNotifyMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeAutoNotifyButtons);
  id = getglobal( "PS_OptionsFormMapIconMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeMapIconButtons);
  id = getglobal( "PS_OptionsFormPopupMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakePopupModeButtons);
  id = getglobal( "PS_OptionsFormTimeMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTimeButtons);
  id = getglobal( "PS_OptionsFormScaleMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeScaleButtons);
  id = getglobal( "PS_OptionsFormAddonMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeAddonButtons);
  id = getglobal( "PS_OptionsFormDeathMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeDeathButtons);
  id = getglobal( "PS_OptionsFormShowMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeShowButtons);
  id = getglobal( "PS_OptionsFormMOMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeMOButtons);
  id = getglobal( "PS_OptionsFormSplitType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeSplitButtons);
  id = getglobal( "PS_OptionsFormKeepType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeKeepButtons);
  id = getglobal( "PS_OptionsFormPetMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakePetButtons);
  id = getglobal( "PS_OptionsFormGrabSpellMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeGrabSpellButtons);
  id = getglobal( "PS_OptionsFormDamageMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeDamageButtons);
  id = getglobal( "PS_OptionsFormHealerMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeHealerButtons);
  id = getglobal( "PS_OptionsFormHealMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeHealButtons);
  if PSvars.tracker then
    id = getglobal( "PS_OptionsFormTrackMode" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTrackButtons);
    id = getglobal( "PS_OptionsFormBGType" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeBGButtons);
    id = getglobal( "PS_OptionsFormPingMode" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakePingModeButtons);
    id = getglobal( "PS_OptionsFormTooltipMode" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTooltipModeButtons);
    PS_OptionsFormTrackers:Show();
    PS_OptionsFormTrackLabel:Show();
    PS_OptionsFormTrackMode:Show();
    PS_OptionsFormColorModeLabel:Show();
    PS_OptionsFormTooltipMode:Show();
    PS_OptionsFormPingType:Show();
    PS_OptionsFormPingMode:Show();
    PS_OptionsFormBGMode:Show();
    PS_OptionsFormBGType:Show();
  end
end

function PS_OptionsForm_MakeKeepButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormKeepType"), KeepList, PS_KeepMode, PS_OptionsForm_MakeKeepButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormKeepType"), i, 0);
end

function PS_OptionsForm_MakeKeepButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormKeepType"), this:GetID(), 0);
  PS_KeepMode = this:GetText();
end

function PS_OptionsForm_MakeSplitButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormSplitType"), KeepList, PS_SplitMode, PS_OptionsForm_MakeSplitButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSplitType"), i, 0);
end

function PS_OptionsForm_MakeSplitButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSplitType"), this:GetID(), 0);
  PS_SplitMode = this:GetText();
end

function PS_OptionsForm_MakeBGButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormBGType"), AddonMode, PS_BG, PS_OptionsForm_MakeBGButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormBGType"), i, 0);
end

function PS_OptionsForm_MakeBGButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormBGType"), this:GetID(), 0);
  PS_BG = this:GetText();
end

function PS_OptionsForm_MakeSentryButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormSentryType"), KeepList, PS_Sentry, PS_OptionsForm_MakeSentryButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSentryType"), i, 0);
end

function PS_OptionsForm_MakeSentryButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSentryType"), this:GetID(), 0);
  PS_Sentry = this:GetText();
end

function PS_OptionsForm_MakeNeutralButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormSentryNeut"), KeepList, PS_Neutral, PS_OptionsForm_MakeNeutralButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSentryNeut"), i, 0);
end

function PS_OptionsForm_MakeNeutralButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSentryNeut"), this:GetID(), 0);
  PS_Neutral = this:GetText();
end

function PS_OptionsForm_MakeSoundButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormSoundType"), KeepList, PS_Sound, PS_OptionsForm_MakeSoundButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSoundType"), i, 0);
end

function PS_OptionsForm_MakeSoundButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormSoundType"), this:GetID(), 0);
  PS_Sound = this:GetText();
end

function PS_OptionsForm_MakePingModeButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormPingMode"), PingModeList, PS_PingMode, PS_OptionsForm_MakePingModeButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPingMode"), i, 0);
end

function PS_OptionsForm_MakePingModeButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPingMode"), this:GetID(), 0);
  PS_PingMode = this:GetText();
end

function PS_OptionsForm_MakePopupModeButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormPopupMode"), PopupModeList, PS_PopupMode, PS_OptionsForm_MakePopupModeButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPopupMode"), i, 0);
end

function PS_OptionsForm_MakePopupModeButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPopupMode"), this:GetID(), 0);
  PS_PopupMode = this:GetText();
end

function PS_OptionsForm_MakeTooltipModeButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormTooltipMode"), TooltipModeList, PS_TooltipMode, PS_OptionsForm_MakeTooltipModeButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTooltipMode"), i, 0);
end

function PS_OptionsForm_MakeTooltipModeButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTooltipMode"), this:GetID(), 0);
  PS_TooltipMode = this:GetText();
end

function PS_OptionsForm_MakeMapIconButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormMapIconMode"), IconList, PS_IconMode, PS_OptionsForm_MakeMapIconButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormMapIconMode"), i, 0);
end

function PS_OptionsForm_MakeMapIconButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormMapIconMode"), this:GetID(), 0);
  PS_IconMode = this:GetText();
end

function PS_OptionsForm_MakeStorageButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal( "PS_OptionsFormStorageMode"), StorageMode, PS_Storage, PS_OptionsForm_MakeStorageButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormStorageMode"), i, 0);
end

function PS_OptionsForm_MakeStorageButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormStorageMode"), this:GetID(), 0);
  PS_Storage = this:GetText();
end

function PS_OptionsForm_MakeAnnounceButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormAnnounceMode"), AnnounceMode, PS_Announce, PS_OptionsForm_MakeAnnounceButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAnnounceMode"), i, 0);
end

function PS_OptionsForm_MakeAnnounceButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAnnounceMode"), this:GetID(), 0);
  PS_Announce = this:GetText();
end

function PS_OptionsForm_MakeAutoNotifyButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal( "PS_OptionsFormAutoNotifyMode"), AutoList, PS_AutoNotify, PS_OptionsForm_MakeAutoNotifyButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAutoNotifyMode"), i, 0);
end

function PS_OptionsForm_MakeAutoNotifyButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAutoNotifyMode"), this:GetID(), 0);
  PS_AutoNotify = this:GetText();
end

function PS_OptionsForm_MakeTimeButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormTimeMode"), TimeMode, PS_Time, PS_OptionsForm_MakeTimeButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTimeMode"), i, 0);
end

function PS_OptionsForm_MakeTimeButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTimeMode"), this:GetID(), 0);
  PS_Time = this:GetText();
end

function PS_OptionsForm_MakeHealButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormHealMode"), HealMode, PS_Heal, PS_OptionsForm_MakeHealButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormHealMode"), i, 0);
end

function PS_OptionsForm_MakeHealButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormHealMode"), this:GetID(), 0);
  PS_Heal = this:GetText();
end

function PS_OptionsForm_MakeScaleButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormScaleMode"), ScaleMode, PS_Scale, PS_OptionsForm_MakeScaleButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormScaleMode"), i, 0);
end

function PS_OptionsForm_MakeScaleButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormScaleMode"), this:GetID(), 0);
  PS_Scalee = this:GetText();
end

function PS_OptionsForm_MakeMOButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormMOMode"), MOMode, PS_MO, PS_OptionsForm_MakeMOButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormMOMode"), i, 0);
end

function PS_OptionsForm_MakeMOButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormMOMode"), this:GetID(), 0);
  PS_MO = this:GetText();
end

function PS_OptionsForm_MakeTrackButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormTrackMode"), TrackMode, PS_Track, PS_OptionsForm_MakeTrackButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTrackMode"), i, 0);
end

function PS_OptionsForm_MakeTrackButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormTrackMode"), this:GetID(), 0);
  PS_Track = this:GetText();
end

function PS_OptionsForm_MakeAddonButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormAddonMode"), AddonMode, PS_Addon, PS_OptionsForm_MakeAddonButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAddonMode"), i, 0);
end

function PS_OptionsForm_MakeAddonButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormAddonMode"), this:GetID(), 0);
  PS_Addon = this:GetText();
end

function PS_OptionsForm_MakeDeathButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormDeathMode"), KeepList, PS_Death, PS_OptionsForm_MakeDeathButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormDeathMode"), i, 0);
end

function PS_OptionsForm_MakeDeathButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormDeathMode"), this:GetID(), 0);
  PS_Death = this:GetText();
end

function PS_OptionsForm_MakeShowButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormShowMode"), KeepList, PS_Show, PS_OptionsForm_MakeShowButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormShowMode"), i, 0);
end

function PS_OptionsForm_MakeShowButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormShowMode"), this:GetID(), 0);
  PS_Show = this:GetText();
end

function PS_OptionsForm_MakePetButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormPetMode"), KeepList, PS_Pet, PS_OptionsForm_MakePetButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPetMode"), i, 0);
end

function PS_OptionsForm_MakePetButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormPetMode"), this:GetID(), 0);
  PS_Pet = this:GetText();
end

function PS_OptionsForm_MakeGrabSpellButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormGrabSpellMode"), KeepList, PS_GrabSpell, PS_OptionsForm_MakeGrabSpellButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormGrabSpellMode"), i, 0);
end

function PS_OptionsForm_MakeGrabSpellButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormGrabSpellMode"), this:GetID(), 0);
  PS_GrabSpell = this:GetText();
end

function PS_OptionsForm_MakeDamageButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormDamageMode"), KeepList, PS_Damage, PS_OptionsForm_MakeDamageButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormDamageMode"), i, 0);
end

function PS_OptionsForm_MakeDamageButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormDamageMode"), this:GetID(), 0);
  PS_Damage = this:GetText();
end

function PS_OptionsForm_MakeHealerButtons()

  local i = PS_OptionsForm_MakeDDButtons(getglobal("PS_OptionsFormHealerMode"), KeepList, PS_Healer, PS_OptionsForm_MakeHealerButtonsClick);
  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormHealerMode"), i, 0);
end

function PS_OptionsForm_MakeHealerButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal("PS_OptionsFormHealerMode"), this:GetID(), 0);
  PS_Healer = this:GetText();
end

function PS_OptionsForm_MakeDDButtons(dropdown, list, presel, func)

  local i = 0;
  local info = {};
  local checked = false;
  local preselindex = 1;
  for  i = 1, table.getn(list) do
    info = {};
    info.width = 100;
    info.text = list[i];
    info.value = list[i];
    info.func = func;
    if( presel == list[i] ) then
      preselindex = i;
    end
    UIDropDownMenu_AddButton(info);
  end
  return preselindex;
end

function PS_OptionsForm_InitializeOptions()

  oldMO = PS_MO;
  oldTrack = PSvars.tracking;
  MaxBackup = PSvars.MaxTargets;
  if PSvars.SetTime == 15 then
    PS_Time = PS_15S
  elseif PSvars.SetTime == 30 then
    PS_Time = PS_SEC;
  elseif PSvars.SetTime == 60 then
    PS_Time = PS_MIN;
  elseif PSvars.SetTime == 180 then
    PS_Time = PS_3MIN;
  elseif PSvars.SetTime == 300 then
    PS_Time = PS_5MIN;
  elseif PSvars.SetTime == 600 then
    PS_Time = PS_10M;
  else
    PS_Time = PS_AOFF;
  end
  if PSvars.HealTime == 20 then
    PS_Heal = PS_20S
  elseif PSvars.HealTime == 40 then
    PS_Heal = PS_40S;
  elseif PSvars.HealTime == 60 then
    PS_Heal = PS_MIN;
  elseif PSvars.HealTime == 120 then
    PS_Heal = PS_2MIN;
  elseif PSvars.HealTime == 180 then
    PS_Heal = PS_3MIN;
  else
    PS_Heal = PS_AOFF;
  end
  PS_Scalebackup = PSvars.scale;
  if PSvars.scale == 1 then
    PS_Scale = PS_LARGE;
  elseif PSvars.scale == .85 then
    PS_Scale = PS_MEDIUM;
  elseif PSvars.scale == .7 then
    PS_Scale = PS_SMALL;
  else
    PS_Scale = PS_TINY;
  end
  if PSvars.Addons == "ON" then
    PS_Addon = PS_ENA;
  elseif PSvars.Addons == "OFF" then
	PS_Addon = PS_DIS;
  elseif PSvars.Addons == "BG" then
    PS_Addon = PS_BGAO;
  else
    PS_Addon = PS_OOBG;
  end
  if not PSvars.AutoNotify then
    PS_AutoNotify = PS_DIS;
  elseif PSvars.AutoNotify == true then
	PS_AutoNotify = PS_ENA;
  else
    PS_AutoNotify = PS_ATT;
  end
  if PSvars.Damage then
    PS_Damage = PS_ENA;
  else
	PS_Damage = PS_DIS;
  end
  if PSvars.Healer then
    PS_Healer = PS_ENA;
  else
	PS_Healer = PS_DIS;
  end
  if PSvars.GrabSpell then
    PS_GrabSpell = PS_ENA;
  else
	PS_GrabSpell = PS_DIS;
  end
  if PSvars.GrabPet then
    PS_Pet = PS_ENA;
  else
	PS_Pet = PS_DIS;
  end
  if PSvars.DeathDetect then
    PS_Death = PS_ENA;
  else
	PS_Death = PS_DIS;
  end
  if PSvars.ShowPet then
    PS_Show = PS_ENA;
  else
	PS_Show = PS_DIS;
  end
  if PSvars.SentryMode then
    PS_Sentry = PS_ENA;
  else
	PS_Sentry = PS_DIS;
  end
  if PSvars.SentryChk then
    PS_Neutral = PS_DIS;
  else
	PS_Neutral = PS_ENA;
  end
  if PSvars.SentrySound then
    PS_Sound = PS_ENA;
  else
	PS_Sound = PS_DIS;
  end
  if PSvars.MO == "FLAGGED AND ELITE ENEMIES" then
    PS_MO = PS_FEE;
  elseif PSvars.MO == "ENEMIES" then
    PS_MO = PS_NME;
  elseif PSvars.MO == "ALL PLAYERS" then
    PS_MO = PS_PLA;
  elseif PSvars.MO == "ENEMY PLAYERS" then
    PS_MO = PS_NMEP;
  else
    PS_MO = PS_ALL;
  end
  if PSvars.tracking == "FLAGGED AND ELITE ENEMIES" then
    PS_Track = PS_FEE;
  elseif PSvars.tracking == "ENEMIES" then
    PS_Track = PS_NME;
  elseif PSvars.tracking == "ALL PLAYERS" then
    PS_Track = PS_PLA;
  elseif PSvars.tracking == "ENEMY PLAYERS" then
    PS_Track = PS_NMEP;
  else
    PS_Track = PS_ALL;
  end
  if PSvars.PopupMode == "UPWARD" then
    PS_PopupMode = PS_UPM;
  else
    PS_PopupMode = PS_DPM;
  end
  PS_PMbackup = PS_PopupMode;
  if PSvars.BGMode == true then
    PS_BG = PS_ENA;
  elseif PSvars.BGMode == false then
    PS_BG = PS_DIS;
  elseif PSvars.BGMode == "BG" then
    PS_BG = PS_BGAO;
  else
    PS_BG = PS_OOBG;
  end
  if PSvars.Split then
    PS_SplitMode = PS_ENA;
  else
    PS_SplitMode = PS_DIS;
  end
  if PSvars.KeepBG then
    PS_KeepMode = PS_ENA;
  else
    PS_KeepMode = PS_DIS;
  end
  if PSvars.announce == "AUTO" then
    PS_Announce = PS_AUTO;
  elseif PSvars.announce == "SAY" then
    PS_Announce = PS_SAY;
  elseif PSvars.announce == "SELF" then
    PS_Announce = PS_SELF;
  elseif PSvars.announce == "YELL" then
    PS_Announce = PS_YELL;
  elseif PSvars.announce == "PARTY" then
    PS_Announce = PS_PARTY;
  elseif PSvars.announce == "RAID" then
    PS_Announce = PS_RAID;
  elseif PSvars.announce == "LOCALDEFENSE" then
    PS_Announce = PS_LD;
  else
    PS_Announce = PS_AOFF;
  end
  if PSvars.storage == "PLAYERS" then
    PS_Storage = PS_PLA;
  elseif PSvars.storage == "ALL" then
    PS_Storage = PS_ALL;
  elseif PSvars.storage == "NONE" then
    PS_Storage = PS_NONE;
  else
    PS_Storage = "NPCS";
  end
  if PSvars.MiniIcon == 1 then
    PS_IconMode = PS_IFM;
  elseif PSvars.MiniIcon == 2 then
    PS_IconMode = PS_IOM;
  else
    PS_IconMode = PS_AOFF;
  end
  if PSvars.ColorMode == "CLASS LEVEL" then
    PS_TooltipMode = PS_LCLS;
  elseif PSvars.ColorMode == "CLASS" then
    PS_TooltipMode = PS_CLS;
  else
    PS_TooltipMode = PS_NORM;
  end
  if PSvars.PingMode == "INSIDE BG" then
    PS_PingMode = PS_PIBG;
  elseif PSvars.PingMode == "OUTSIDE BG" then
    PS_PingMode = PS_POBG;
  elseif PSvars.PingMode == "DEFAULT" then
    PS_PingMode = PS_ALW;
  elseif PSvars.PingMode == "WHEN ANNOUNCING" then
    PS_PingMode = PS_PWA;
  else
    PS_PingMode = PS_AOFF;
  end
  PS_OptionsFormCheckButton1:SetChecked(PSvars.ClassBGcolors);
  PS_OptionsFormCheckButton2:SetChecked(PSvars.ClassTextcolors);
  PS_OptionsFormMaxSlider:SetValue(PSvars.MaxTargets);
  GameTooltip:Hide();
  PSvars_ClassBGColors = PSvars.ClassBGcolors;
  PSvars_ClassTextColors = PSvars.ClassTextcolors;
  PSvars_MaxTargets = PSvars.MaxTargets - 1;
  PS_OptionsForm_LoadCombos();
  PS_OptionsForm_LoadColors();
end

function PS_OptionsForm_LoadColors()

  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( PSvars.EnemyPlayer.r, PSvars.EnemyPlayer.g, PSvars.EnemyPlayer.b );
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( PSvars.EnemyNPC.r, PSvars.EnemyNPC.g, PSvars.EnemyNPC.b );
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( PSvars.FriendlyPlayer.r, PSvars.FriendlyPlayer.g, PSvars.FriendlyPlayer.b );
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( PSvars.FriendlyNPC.r, PSvars.FriendlyNPC.g, PSvars.FriendlyNPC.b );
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( PSvars.UNKPlayer.r, PSvars.UNKPlayer.g, PSvars.UNKPlayer.b );
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( PSvars.UNKNPC.r, PSvars.UNKNPC.g, PSvars.UNKNPC.b );

  getglobal("PS_OptionsForm_PlayerEnemyTColorColor"):SetTexture( PSvars.EnemyPlayerT.r, PSvars.EnemyPlayerT.g, PSvars.EnemyPlayerT.b );
  getglobal("PS_OptionsForm_NPCEnemyTColorColor"):SetTexture( PSvars.EnemyNPCT.r, PSvars.EnemyNPCT.g, PSvars.EnemyNPCT.b );
  getglobal("PS_OptionsForm_PlayerFriendlyTColorColor"):SetTexture( PSvars.FriendlyPlayerT.r, PSvars.FriendlyPlayerT.g, PSvars.FriendlyPlayerT.b );
  getglobal("PS_OptionsForm_NPCFriendlyTColorColor"):SetTexture( PSvars.FriendlyNPCT.r, PSvars.FriendlyNPCT.g, PSvars.FriendlyNPCT.b );
  getglobal("PS_OptionsForm_UNKPlayerTColorColor"):SetTexture( PSvars.UNKPlayerT.r, PSvars.UNKPlayerT.g, PSvars.UNKPlayerT.b );
  getglobal("PS_OptionsForm_UNKNPCTColorColor"):SetTexture( PSvars.UNKNPCT.r, PSvars.UNKNPCT.g, PSvars.UNKNPCT.b );
  getglobal("PS_OptionsForm"):SetScale(.75);
end

function PS_OptionsForm_SaveOptions()

  local settime = getglobal("PS_OptionsFormTimeModeText");
  local scale = getglobal("PS_OptionsFormScaleModeText");
  local sentrymode = getglobal("PS_OptionsFormSentryTypeText");
  local neutral = getglobal("PS_OptionsFormSentryNeutText");
  local soundmode = getglobal("PS_OptionsFormSoundTypeText");
  local bgmode 	= getglobal("PS_OptionsFormBGTypeText");
  local storage	= getglobal("PS_OptionsFormStorageModeText");
  local announce = getglobal("PS_OptionsFormAnnounceModeText");
  local autonotify = getglobal("PS_OptionsFormAutoNotifyModeText");
  local IconMode = getglobal("PS_OptionsFormMapIconModeText");
  local colormode = getglobal("PS_OptionsFormTooltipModeText");
  local popupmode = getglobal("PS_OptionsFormPopupModeText");
  local pingmode = getglobal("PS_OptionsFormPingModeText");
  local MO = getglobal("PS_OptionsFormMOModeText");
  local tracking = getglobal("PS_OptionsFormTrackModeText");
  local addon = getglobal("PS_OptionsFormAddonModeText");
  local death = getglobal("PS_OptionsFormDeathModeText");
  local show = getglobal("PS_OptionsFormShowModeText");
  local splitmode = getglobal("PS_OptionsFormSplitTypeText");
  local keepmode = getglobal("PS_OptionsFormKeepTypeText");
  local pet = getglobal("PS_OptionsFormPetModeText");
  local grabspell = getglobal("PS_OptionsFormGrabSpellModeText");
  local damage = getglobal("PS_OptionsFormDamageModeText");
  local healer = getglobal("PS_OptionsFormHealerModeText");
  local heal = getglobal("PS_OptionsFormHealModeText");
  local thelist = PS_thelist;
  if settime:GetText() == PS_15S then
    PSvars.SetTime = 15;
  elseif settime:GetText() == PS_SEC then
    PSvars.SetTime = 30;
  elseif settime:GetText() == PS_MIN then
    PSvars.SetTime = 60;
  elseif settime:GetText() == PS_3MIN then
    PSvars.SetTime = 180;
  elseif settime:GetText() == PS_5MIN then
    PSvars.SetTime = 300;
  elseif settime:GetText() == PS_10M then
    PSvars.SetTime = 600;
  else
    PSvars.SetTime = 9999;
  end
  if heal:GetText() == PS_20S then
    PSvars.HealTime = 20;
  elseif heal:GetText() == PS_40S then
    PSvars.HealTime = 40;
  elseif heal:GetText() == PS_MIN then
    PSvars.HealTime = 60;
  elseif heal:GetText() == PS_2MIN then
    PSvars.HealTime = 120;
  elseif heal:GetText() == PS_3MIN then
    PSvars.HealTime = 180;
  else
    PSvars.HealTime = 9999;
  end
  if scale:GetText() == PS_LARGE then
    PSvars.scale = 1;
  elseif scale:GetText() == PS_MEDIUM then
    PSvars.scale = .85;
  elseif scale:GetText() == PS_SMALL then
    PSvars.scale = .7;
  else
    PSvars.scale = .55;
  end
  if PSvars.scale ~= PS_Scalebackup then
    PS_Clear_Popup();
    PS_addpop = 0;
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  end
  if sentrymode:GetText() == PS_ENA then
    PSvars.SentryMode = true;
  else
    PSvars.SentryMode = false;
  end
  if neutral:GetText() == PS_ENA then
    PSvars.SentryChk = false;
  else
    PSvars.SentryChk = true;
  end
  if autonotify:GetText() == PS_ENA then
    PSvars.AutoNotify = true;
  elseif autonotify:GetText() == PS_DIS then
    PSvars.AutoNotify = false;
  else
    PSvars.AutoNotify = "DAMAGE";
  end
  if soundmode:GetText() == PS_ENA then
    PSvars.SentrySound = true;
  else
    PSvars.SentrySound = false;
  end
  if death:GetText() == PS_ENA then
    PSvars.DeathDetect = true;
  else
    PSvars.DeathDetect = false;
  end
  if show:GetText() == PS_ENA then
    PSvars.ShowPet = true;
  else
    PSvars.ShowPet = false;
    if PS_tpos > 1 then
      PS_addpop = 0;
      PS_Enemy = 0;
      PS_thelist = "";
      PS_KeepDamage(thelist);
      PS_Process_Tooltip(thelist);
    end
  end
  if damage:GetText() == PS_ENA then
    PSvars.Damage = true;
  else
    PSvars.Damage = false;
  end
  if healer:GetText() == PS_ENA then
    PSvars.Healer = true;
  else
    PSvars.Healer = false;
  end
  if pet:GetText() == PS_ENA then
    PSvars.GrabPet = true;
  else
    PSvars.GrabPet = false;
  end
  if grabspell:GetText() == PS_ENA then
    PSvars.GrabSpell = true;
  else
    PSvars.GrabSpell = false;
  end
  if IconMode:GetText() == PS_AOFF then
    PSvars.MiniIcon = 0;
    PS_ToggleMinimapButton();
  elseif IconMode:GetText() == PS_IFM then
    PSvars.MiniIcon = 1;
    PS_ToggleMinimapButton();
  else
    PSvars.MiniIcon = 2;
    PS_ToggleMinimapButton();
  end
  if bgmode:GetText() == PS_ENA then
    PSvars.BGMode = true;
  elseif bgmode:GetText() == PS_DIS then
    PSvars.BGMode = false;
  elseif bgmode:GetText() == PS_BGAO then
    PSvars.BGMode = "BG";
  else
    PSvars.BGMode = "NOBG";
  end
  if keepmode:GetText() == PS_ENA then
    PSvars.KeepBG = true;
  else
    PSvars.KeepBG = false;
  end
  if splitmode:GetText() == PS_ENA then
    PS_Clear_Popup();
    PS_addpop = 0;
    PS_dim = 1;
    PSvars.Split = true;
    PS_Process_Tooltip(PS_thelist);
  else
    PS_Clear_Popup();
    PS_dim = 1;
    PS_addpop = 0;
    PSvars.Split = false;
    PS_Process_Tooltip(PS_thelist);
  end
  if storage:GetText() == PS_PLA then
    PSvars.storage = "PLAYERS";
  elseif storage:GetText() == PS_ALL then
    PSvars.storage = "ALL";
  elseif storage:GetText() == PS_NONE then
    PSvars.storage = "NONE";
  else
    PSvars.storage = "NPC";
  end
  if announce:GetText() == PS_SELF then
    PSvars.announce = "SELF";
  elseif announce:GetText() == PS_SAY then
    PSvars.announce = "SAY";
  elseif announce:GetText() == PS_PARTY then
    PSvars.announce = "PARTY";
  elseif announce:GetText() == PS_RAID then
    PSvars.announce = "RAID";
  elseif announce:GetText() == PS_YELL then
    PSvars.announce = "YELL";
  elseif announce:GetText() == PS_LD then
    PSvars.announce = "LOCALDEFENSE";
  elseif announce:GetText() == PS_AUTO then
    PSvars.announce = "AUTO";
  else
    PSvars.announce = "OFF";
  end
  if popupmode:GetText() == PS_RESET then
    if PSvars.PopupMode == "UPWARD" then
      local frame = getglobal("PS_Popup"..PS_CombatMode..PS_Split.."UPWARD");
      frame:ClearAllPoints();
      frame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 400, 200);
    else
      PS_Frame:ClearAllPoints();
      PS_Frame:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 700, 700);
    end
  elseif popupmode:GetText() ~= PS_PMbackup then
    PS_Clear_Popup();
    PS_addpop = 0;
    PS_dim = 1;
    if popupmode:GetText() == PS_UPM then
      PSvars.PopupMode = "UPWARD";
    else
      PSvars.PopupMode = "DOWNWARD";
    end
    PS_Process_Tooltip(PS_thelist);
  end
  if PSvars.tracker then
    if colormode:GetText() == PS_NORM then
      PSvars.ColorMode = "NORMAL";
    elseif colormode:GetText() == PS_CLS then
      PSvars.ColorMode = "CLASS";
    else
      PSvars.ColorMode = "CLASS LEVEL";
    end
    if pingmode:GetText() == PS_ALW then
      PSvars.PingMode = "DEFAULT";
    elseif pingmode:GetText() == PS_PIBG then
      PSvars.PingMode = "INSIDE BG";
    elseif pingmode:GetText() == PS_POBG then
      PSvars.PingMode = "OUTSIDE BG";
    elseif pingmode:GetText() == PS_PWA then
      PSvars.PingMode = "WHEN ANNOUNCING";
    else
      PSvars.PingMode = "OFF";
    end
  end
  if oldTrack ~= tracking:GetText() then
    if tracking:GetText() == PS_FEE then
      PSvars.tracking = "FLAGGED AND ELITE ENEMIES";
    elseif tracking:GetText() == PS_PLA then
      PSvars.tracking = "ALL PLAYERS";
    elseif tracking:GetText() == PS_NME then
      PSvars.tracking = "ENEMIES";
    elseif tracking:GetText() == PS_NMEP then
      PSvars.tracking = "ENEMY PLAYERS";
    else
      PSvars.tracking = "ALL";
    end
    if PS_tpos > 1 then
      PS_addpop = 0;
      PS_Enemy = 0;
      PS_thelist = "";
      PS_KeepDamage(thelist);
      PS_Process_Tooltip(thelist);
    end
  end
  if addon:GetText() == PS_ENA then
    PSvars.Addons = "ON";
  elseif addon:GetText() == PS_DIS then
    PSvars.Addons = "OFF";
    PS_Clear_Popup();
    PS_thelist = "";
    PSvars.list = {};
    PS_TraceFrame(PS_DISABLED);
  elseif addon:GetText() == PS_BGAO then
    PSvars.Addons = "BG";
    if not PS_bgmode then
      PS_Clear_Popup();
      PS_thelist = "";
      PSvars.list = {};
    end
  else
    PSvars.Addons = "NOBG";
    if PS_bgmode then
      PS_Clear_Popup();
      PS_thelist = "";
      PSvars.list = {};
    end
  end
  if oldMO ~= MO:GetText() then
    if MO:GetText() == PS_FEE then
      PSvars.MO = "FLAGGED AND ELITE ENEMIES";
    elseif MO:GetText() == PS_PLA then
      PSvars.MO = "ALL PLAYERS";
    elseif MO:GetText() == PS_NME then
      PSvars.MO = "ENEMIES";
    elseif MO:GetText() == PS_NMEP then
      PSvars.MO = "ENEMY PLAYERS";
    else
      PSvars.MO = "ALL";
    end
    if PS_tpos > 1 then
      PS_addpop = 0;
      PS_Enemy = 0;
      PS_thelist = "";
      PS_KeepDamage(thelist);
      PS_Process_Tooltip(thelist);
    end
  end
  if PSvars_ClassBGColors then
    PSvars.ClassBGcolors = true;
  else
    PSvars.ClassBGcolors = false;
  end
  if PSvars_ClassTextColors then
    PSvars.ClassTextcolors = true;
  else
    PSvars.ClassTextcolors = false;
  end
  PS_Clear_Popup();
  PSvars.MaxTargets = PSvars_MaxTargets + 1;
  if MaxBackup > PSvars.MaxTargets then
    local thelist = PS_thelist;
    PS_thelist = "";
    PSvars.list = {};
    PS_addpop = 0;
    PS_Process_Tooltip(thelist);
  else
    PS_dim = 1;
    PS_addpop = 0;
    PS_Process_Tooltip(PS_thelist);
  end
  PS_OptionsForm:Hide();
end

function PS_DisplayColorPicker( colorvar, colorfunc, cancelfunc )

  PlaySound("igMainMenuOptionCheckBoxOn");
  ColorPickerFrame.func = colorfunc;
  ColorPickerFrame.cancelFunc = cancelfunc;
  ColorPickerFrame:SetColorRGB( colorvar.r, colorvar.g, colorvar.b );
  ColorPickerFrame.previousValues = { colorvar.r, colorvar.g, colorvar.b };
  ShowUIPanel(ColorPickerFrame);
end

function PSvars_EnemyPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayer.r = r;
  PSvars.EnemyPlayer.g = g;
  PSvars.EnemyPlayer.b = b;
end


function PSvars_EnemyPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayer.r = r;
  PSvars.EnemyPlayer.g = g;
  PSvars.EnemyPlayer.b = b;
end

function PSvars_EnemyNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPC.r = r;
  PSvars.EnemyNPC.g = g;
  PSvars.EnemyNPC.b = b;
end


function PSvars_EnemyNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPC.r = r;
  PSvars.EnemyNPC.g = g;
  PSvars.EnemyNPC.b = b;
end

function PSvars_FriendlyPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayer.r = r;
  PSvars.FriendlyPlayer.g = g;
  PSvars.FriendlyPlayer.b = b;
end


function PSvars_FriendlyPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayer.r = r;
  PSvars.FriendlyPlayer.g = g;
  PSvars.FriendlyPlayer.b = b;
end

function PSvars_FriendlyNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPC.r = r;
  PSvars.FriendlyNPC.g = g;
  PSvars.FriendlyNPC.b = b;
end


function PSvars_FriendlyNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPC.r = r;
  PSvars.FriendlyNPC.g = g;
  PSvars.FriendlyNPC.b = b;
end

function PSvars_UNKPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayer.r = r;
  PSvars.UNKPlayer.g = g;
  PSvars.UNKPlayer.b = b;
end


function PSvars_UNKPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayer.r = r;
  PSvars.UNKPlayer.g = g;
  PSvars.UNKPlayer.b = b;
end

function PSvars_UNKNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPC.r = r;
  PSvars.UNKNPC.g = g;
  PSvars.UNKNPC.b = b;
end


function PSvars_UNKNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPC.r = r;
  PSvars.UNKNPC.g = g;
  PSvars.UNKNPC.b = b;
end



function PSvars_EnemyPlayerT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerEnemyTColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayerT.r = r;
  PSvars.EnemyPlayerT.g = g;
  PSvars.EnemyPlayerT.b = b;
end


function PSvars_EnemyPlayerT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerEnemyTColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayerT.r = r;
  PSvars.EnemyPlayerT.g = g;
  PSvars.EnemyPlayerT.b = b;
end

function PSvars_EnemyNPCT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCEnemyTColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPCT.r = r;
  PSvars.EnemyNPCT.g = g;
  PSvars.EnemyNPCT.b = b;
end


function PSvars_EnemyNPCT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCEnemyTColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPCT.r = r;
  PSvars.EnemyNPCT.g = g;
  PSvars.EnemyNPCT.b = b;
end

function PSvars_FriendlyPlayerT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerFriendlyTColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayerT.r = r;
  PSvars.FriendlyPlayerT.g = g;
  PSvars.FriendlyPlayerT.b = b;
end


function PSvars_FriendlyPlayerT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerFriendlyTColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayerT.r = r;
  PSvars.FriendlyPlayerT.g = g;
  PSvars.FriendlyPlayerT.b = b;
end

function PSvars_FriendlyNPCT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCFriendlyTColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPCT.r = r;
  PSvars.FriendlyNPCT.g = g;
  PSvars.FriendlyNPCT.b = b;
end


function PSvars_FriendlyNPCT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCFriendlyTColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPCT.r = r;
  PSvars.FriendlyNPCT.g = g;
  PSvars.FriendlyNPCT.b = b;
end

function PSvars_UNKPlayerT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKPlayerTColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayerT.r = r;
  PSvars.UNKPlayerT.g = g;
  PSvars.UNKPlayerT.b = b;
end


function PSvars_UNKPlayerT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKPlayerTColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayerT.r = r;
  PSvars.UNKPlayerT.g = g;
  PSvars.UNKPlayerT.b = b;
end

function PSvars_UNKNPCT_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKNPCTColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPCT.r = r;
  PSvars.UNKNPCT.g = g;
  PSvars.UNKNPCT.b = b;
end


function PSvars_UNKNPCT_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKNPCTColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPCT.r = r;
  PSvars.UNKNPCT.g = g;
  PSvars.UNKNPCT.b = b;
end
