function PS_Minimap_IconFrame_OnClick2(button)

  if ( button == "RightButton" ) then
    if not PS_OptionsForm:IsVisible() then
      PS_OptionsForm_InitializeOptions();
      PS_OptionsForm:Show();
    else
      PS_OptionsForm:Hide();
    end
  end
end

local function move_icon2()

  PS_Minimap_IconFrame2:SetPoint("TOPLEFT", "Minimap", "TOPLEFT", 52-(80*cos(PSvars.MinimapIconPos or 45)),(80*sin(PSvars.MinimapIconPos or 45))-52)
end

function PS_Minimap_IconFrame_OnEvent2(arg1, arg2)

  if (event=="VARIABLES_LOADED") then
    PS_Minimap_RefreshMinimap2();
    move_icon2();
  end
end

function PS_Minimap_RefreshMinimap2()

  if PSvars.MiniIcon == 2 then
    PS_Minimap_IconFrame2:Show();
    PS_Minimap_IconFrame:Hide();
  elseif PSvars.MiniIcon == 0 then
    PS_Minimap_IconFrame2:Hide();
  end
end

function PS_Minimap_IconDraggingFrame_OnUpdate2(arg1)

  local xpos,ypos = GetCursorPosition()
  local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()
  xpos = xmin-xpos/Minimap:GetEffectiveScale()+70
  ypos = ypos/Minimap:GetEffectiveScale()-ymin-70
  PSvars.MinimapIconPos = math.deg(math.atan2(ypos,xpos))
  move_icon2()
end